#include <windows.h>
#include <string.h>
#include "filter.h"
#include <mmintrin.h>
#include <xmmintrin.h>

//---------------------------------------------------------------------
// tB^֐ikXbhAPɊԈꍇASSEj
//---------------------------------------------------------------------
void multi_thread_func_1x1_sse(int thread_id, int thread_num, void *param1, void *param2)
{
    // thread_id   : Xbhԍ ( 0 ` thread_num-1 )
    // thread_num  : Xbh ( 1 ` )
    // param1      : ėpp[^
    // param2      : ėpp[^
    //
    // ̊֐Win32APIO֐gpȂłB
    //

    // l[
    FILTER *fp = (FILTER *)param1;
    FILTER_PROC_INFO *fpip = (FILTER_PROC_INFO *)param2;

    // Xbh̉摜郉CvZ
    int y_start = ((fpip->h / 2) * (thread_id    )) / thread_num;
    int y_end   = ((fpip->h / 2) * (thread_id + 1)) / thread_num;
    int y = (y_end - y_start);

    // [JϐɈړ
    int max_w = fpip->max_w;
    int w_dst = fpip->w / 2;
    int diff_dst = max_w - w_dst;
    int diff_src = max_w * 2 - w_dst * 2;
    PIXEL_YC *ycp_dst = fpip->ycp_temp +  y_start      * max_w;
    PIXEL_YC *ycp_src = fpip->ycp_edit + (y_start * 2) * max_w;
    ycp_src += fp->track[0] + fp->track[1] * max_w; // ĂhbgŒ

    // C̃[v
    while (--y >= 0) {
        int x = w_dst;
        while (--x >= 0) {
        	_mm_stream_pi((__m64 *)ycp_dst, *(__m64 *)ycp_src);
            ycp_src += 2;
            ycp_dst++;
        }
        ycp_src += diff_src;
        ycp_dst += diff_dst;
    }
    _mm_empty();
}

//---------------------------------------------------------------------
// tB^֐ikXbhA4hbguhASSEj
//---------------------------------------------------------------------
void multi_thread_func_2x2_sse(int thread_id, int thread_num, void *param1, void *param2)
{
    // thread_id   : Xbhԍ ( 0 ` thread_num-1 )
    // thread_num  : Xbh ( 1 ` )
    // param1      : ėpp[^
    // param2      : ėpp[^
    //
    // ̊֐Win32APIO֐gpȂłB
    //

    // l[
    //FILTER *fp = (FILTER *)param1;
    FILTER_PROC_INFO *fpip = (FILTER_PROC_INFO *)param2;

    // Xbh̉摜郉CvZ
    int y_start = ((fpip->h / 2) * (thread_id    )) / thread_num;
    int y_end   = ((fpip->h / 2) * (thread_id + 1)) / thread_num;
    int y = (y_end - y_start);

    // [JϐɈړ
    int max_w = fpip->max_w;
    int w_dst = fpip->w / 2;
    int diff_dst = max_w - w_dst;
    int diff_src = max_w * 2 - w_dst * 2;
    PIXEL_YC *ycp_dst = fpip->ycp_temp +  y_start      * max_w;
    PIXEL_YC *ycp_src = fpip->ycp_edit + (y_start * 2) * max_w;
    __m64 cc = _mm_set_pi16(0, 0, 0, 2);

    // C[v
    while (--y >= 0) {
        int x = w_dst;
        while (--x >= 0) {
            // ľܓpcc܂߂đ4Ŋ
        	// 16bit]vɏo͂Ă邪AêŋCɂȂ
            _mm_stream_pi(
            	(__m64 *)ycp_dst,
                _m_psrawi(
                    _m_paddw(
                        _m_paddw(
                            cc,
                            _m_paddw(
                            	*(__m64 *)(ycp_src),
	                            *(__m64 *)(ycp_src + 1)
                            )
                        ),
                        _m_paddw(
                            *(__m64 *)(ycp_src + max_w),
                            *(__m64 *)(ycp_src + max_w + 1)
                        )
                    ),
                    2
                )
            );
            ycp_src  += 2;
            ycp_dst++;
        }
        ycp_src += diff_src;
        ycp_dst += diff_dst;
    }
    _mm_empty();
}

//---------------------------------------------------------------------
// tB^֐ikXbhȀkuhASSEj
//---------------------------------------------------------------------
void multi_thread_func_2x1_sse(int thread_id, int thread_num, void *param1, void *param2)
{
    // thread_id   : Xbhԍ ( 0 ` thread_num-1 )
    // thread_num  : Xbh ( 1 ` )
    // param1      : ėpp[^
    // param2      : ėpp[^
    //
    // ̊֐Win32APIO֐gpȂłB
    //

    // l[
    FILTER *fp = (FILTER *)param1;
    FILTER_PROC_INFO *fpip = (FILTER_PROC_INFO *)param2;

    // Xbh̉摜郉CvZ
    int y_start = ((fpip->h / 2) * (thread_id    )) / thread_num;
    int y_end   = ((fpip->h / 2) * (thread_id + 1)) / thread_num;
    int y = (y_end - y_start);

    // [JϐɈړ
    int max_w = fpip->max_w;
    int w_dst = fpip->w / 2;
    int diff_dst = max_w - w_dst;
    int diff_src = max_w * 2 - w_dst * 2;
    PIXEL_YC *ycp_dst = fpip->ycp_temp +  y_start      * max_w;
    PIXEL_YC *ycp_src = fpip->ycp_edit + (y_start * 2) * max_w;
    ycp_src += fp->track[1] * max_w; // Ă郉CŒ
    __m64 cc = _mm_set_pi16(0, 0, 0, 1);

    // C̃[v
    while (--y >= 0) {
        int x = w_dst;
        while (--x >= 0) {
            // ľܓpcc܂߂đ2Ŋ
        	// 16bit]vɏo͂Ă邪AêŋCɂȂ
            _mm_stream_pi(
	            (__m64 *)ycp_dst,
                _m_psrawi(
                    _m_paddw(
                        _m_paddw(
                            *(__m64 *)(ycp_src),
	                        *(__m64 *)(ycp_src + 1)
                        ),
                        cc
                    ),
                    1
                )
            );
            ycp_src += 2;
            ycp_dst++;
        }
        ycp_src += diff_src;
        ycp_dst += diff_dst;
    }
    _mm_empty();
}

//---------------------------------------------------------------------
// tB^֐ikXbhAc̏kuhASSEj
//---------------------------------------------------------------------
void multi_thread_func_1x2_sse(int thread_id, int thread_num, void *param1, void *param2)
{
    // thread_id   : Xbhԍ ( 0 ` thread_num-1 )
    // thread_num  : Xbh ( 1 ` )
    // param1      : ėpp[^
    // param2      : ėpp[^
    //
    // ̊֐Win32APIO֐gpȂłB
    //

    // l[
    FILTER *fp = (FILTER *)param1;
    FILTER_PROC_INFO *fpip = (FILTER_PROC_INFO *)param2;

    // Xbh̉摜郉CvZ
    int y_start = ((fpip->h / 2) * (thread_id    )) / thread_num;
    int y_end   = ((fpip->h / 2) * (thread_id + 1)) / thread_num;
    int y = (y_end - y_start);

    // [JϐɈړ
    int max_w = fpip->max_w;
    int w_dst = fpip->w / 2;
    int diff_dst = max_w - w_dst;
    int diff_src = max_w * 2 - w_dst * 2;
    PIXEL_YC *ycp_dst = fpip->ycp_temp +  y_start      * max_w;
    PIXEL_YC *ycp_src = fpip->ycp_edit + (y_start * 2) * max_w;
    ycp_src += fp->track[0]; // Ă郉CŒ
    __m64 cc = _mm_set_pi16(0, 0, 0, 1);

    // C̃[v
    while (--y >= 0) {
        int x = w_dst;
        while (--x >= 0) {
            // ľܓpcc܂߂đ2Ŋ
        	// 16bit]vɏo͂Ă邪AêŋCɂȂ
            _mm_stream_pi(
	            (__m64 *)ycp_dst,
                _m_psrawi(
                    _m_paddw(
                        _m_paddw(
                           *(__m64 *)(ycp_src),
 	                       *(__m64 *)(ycp_src + max_w)
                        ),
                        cc
                    ),
                    1
                )
            );
            ycp_src += 2;
            ycp_dst++;
        }
        ycp_src += diff_src;
        ycp_dst += diff_dst;
    }
    _mm_empty();
}
